//-----------------------------------------------------------------------------
//  ^Cgo[Ƀ{^zuăNbNɔ邽߂̃NX
//  BlueLeaf1336    http://www.geocities.jp/fjtkt/

//-----------------------------------------------------------------------------
//  2007.11.26  DrawNewButton ɃNXɂ܂Ƃ߂
//              ̃{^ɑΉ
//  2007.11.27  TO DO Caption or Glyph
//  2007.11.27  TO DO OnClick()
//              TO DO gO`̃{^

//-----------------------------------------------------------------------------
//  QlvO

//1----------------------------------------------------------------------------
//	class CCaptionButton
//		Add push buttons to the caption bar
//
//	Author:		Yao Zhifeng
//	Contact:	yaozhifeng@hotmail.com

//2----------------------------------------------------------------------------
//  _E[hTCgO
//  NewButton.lzh
//  unit DrawNewButton

unit CaptionButton;

interface

uses
    Windows, Messages, Classes, SysUtils, Contnrs, Forms, Graphics;

type
    TOnCaptionButtonClick = procedure (const Index: Integer) of object;

    TCaptionButtons = class;

    TCaptionButton = class
    protected
        Pushed: Boolean;
        Parent: TCaptionButtons;
    public
        Caption: String;
        procedure Draw(const AHDC: HDC; const ARect: TRect);
        constructor Create();
        destructor Destroy(); override;
    end;


    TCaptionButtons = class
    protected
        FTarget :TForm;
        FOriginalWndProc: Pointer;
        FHookWndProc :Pointer;
        FWndHandle :HWND;
        procedure WndProc(var Msg: TMessage); virtual;
    protected
        FButtons: TObjectList;
        FFont: TFont;
        FOnClick: TOnCaptionButtonClick;
        function CaptionHeight(): Integer;
        function CaptionBarRect(): TRect;
        function DefaultButtonCount(): Integer;
        function LeftEndDefaultButtonRect(): TRect;
    protected
        procedure DrawButtons();
        function LeftButtonDown(const APoint: TPoint): Boolean;
        function LeftButtonUp(const APoint: TPoint): Boolean;
    public
        property Font: TFont read FFont;
        property OnClick: TOnCaptionButtonClick read FOnClick write FOnClick;
    public
        constructor Create(ATarget: TForm);
        destructor Destroy(); override;
        function AddButton(): TCaptionButton;
    end;

implementation

//-----------------------------------------------------------------------------
//  TCaptionButton

//-----------------------------------------------------------------------------
//  RXgN^
constructor TCaptionButton.Create();
begin
    inherited Create();
    Pushed := False;
end;

//-----------------------------------------------------------------------------
//  fXgN^
destructor TCaptionButton.Destroy();
begin
    inherited Destroy();
end;

//-----------------------------------------------------------------------------
//  `
procedure TCaptionButton.Draw(const AHDC: HDC; const ARect: TRect);
var
    LRect: TRect;
    LState: Cardinal;
    LFormat: Cardinal;
    LParams: TDrawTextParams;
    LOldMode: Integer;
begin
    //  {^`悷
    LState := DFCS_BUTTONPUSH;
    if (Pushed) then LState := LState or DFCS_PUSHED;
    DrawFrameControl(AHDC, ARect, DFC_BUTTON, LState);

    //  LvV`悷邽߂̐ݒ
    LRect := ARect;
    OffsetRect(LRect, -1, -1);  //  lBC}C`B
    LFormat := DT_CENTER or DT_VCENTER or DT_SINGLELINE;
    FillChar(LParams, SizeOf(LParams), 0);
    LParams.cbSize := SizeOf(LParams);
    //  ĂƂ͏炷
    if (Pushed) then OffsetRect(LRect, 1, 1);

    //  wi
    LOldMode := SetBkMode(AHDC, TRANSPARENT);
    DrawTextEx(AHDC, PChar(Caption), -1, LRect, LFormat, @LParams);
    SetBkMode(AHDC, LOldMode);
end;

//-----------------------------------------------------------------------------
//  TCaptionButtons

//-----------------------------------------------------------------------------
//  RXgN^
constructor TCaptionButtons.Create(ATarget: TForm);
begin
    inherited Create();

    //  {^ێpXg쐬
    FButtons := TObjectList.Create(True);
    //  tHg쐬
    FFont := TFont.Create();
    //  NbNCxg
    FOnClick := nil;

    // ̂ƂRg[ۑ
    FTarget := ATarget;
    // ̃nhۑ
    FWndHandle := FTarget.Handle;
    // uWindowProcedureIuWFNg
    FHookWndProc := Classes.MakeObjectInstance(WndProc);
    // uăIWiۑ
    FOriginalWndProc := Pointer(SetWindowLong(FWndHandle, GWL_WNDPROC,
                                LongInt(FHookWndProc)));
end;

//-----------------------------------------------------------------------------
//  fXgN^
destructor TCaptionButtons.Destroy();
begin
    // ɖ߂
    SetWindowLong(FWndHandle, GWL_WNDPROC, LongInt(FOriginalWndProc));
    //  IuWFNgj
    Classes.FreeObjectInstance(FHookWndProc);

    //  tHgj
    FFont.Free();
    //  {^ێpXgj
    FButtons.Free();
    
    inherited Destroy();
end;

//-----------------------------------------------------------------------------
//  {^`
function TCaptionButtons.AddButton(): TCaptionButton;
begin
    Result := TCaptionButton.Create();
    Result.Parent := Self;
    FButtons.Add(Result);
end;

//-----------------------------------------------------------------------------
//  {^`
procedure TCaptionButtons.DrawButtons();
var
    i: Integer;
    LRect: TRect;
    LBtnWidth: Integer;
    LButton: TCaptionButton;
    LHDC: HDC;
    LOldObj: HGDIOBJ;
begin
    //  W{^[
    LRect := LeftEndDefaultButtonRect();

    //  {^̕
    LBtnWidth := CaptionHeight();// GetSystemMetrics(SM_CXSIZE);

    //  `m
    LHDC := GetWindowDC(FWndHandle);
    LOldObj := SelectObject(LHDC, FFont.Handle);

    //  炵ĕ`
    for i := 0 to FButtons.Count - 1 do
    begin
        LButton := TCaptionButton(FButtons.Items[i]);
        OffsetRect(LRect, -LBtnWidth, 0);
        LButton.Draw(LHDC, LRect);
    end;

    //  `
    SelectObject(LHDC, LOldObj);
    ReleaseDC(FWndHandle, LHDC);
end;

//-----------------------------------------------------------------------------
//  {^ꂩĂ邩`FbN  
function TCaptionButtons.LeftButtonDown(const APoint: TPoint): Boolean;
var
    i: Integer;
    LRect: TRect;
    LBtnWidth: Integer;
    LButton: TCaptionButton;
    LWndRect: TRect;
begin
    Result := False;

    //  W{^[
    LRect := LeftEndDefaultButtonRect();

    //  EBhE̍Ɍ_킹
    GetWindowRect(FWndHandle, LWndRect);
    OffsetRect(LRect, LWndRect.Left, LWndRect.Top);

    //  {^̕
    LBtnWidth := CaptionHeight();// GetSystemMetrics(SM_CXSIZE);

    //  炵ă`FbN
    for i := 0 to FButtons.Count - 1 do
    begin
        LButton := TCaptionButton(FButtons.Items[i]);
        OffsetRect(LRect, -LBtnWidth, 0);
        LButton.Pushed := PtInRect(LRect, APoint);
        if (LButton.Pushed) then Result := True;
    end;
end;

//-----------------------------------------------------------------------------
//  {^ꂽǂ`FbN  
function TCaptionButtons.LeftButtonUp(const APoint: TPoint): Boolean;
var
    i: Integer;
    LRect: TRect;
    LBtnWidth: Integer;
    LButton: TCaptionButton;
    LWndRect: TRect;
    LClickIndex: Integer;
begin
    Result := False;
    LClickIndex := -1;

    //  W{^[
    LRect := LeftEndDefaultButtonRect();

    //  EBhE̍Ɍ_킹
    GetWindowRect(FWndHandle, LWndRect);
    OffsetRect(LRect, LWndRect.Left, LWndRect.Top);

    //  WM_LBUTTONUP ŃNbNoĂ̂ōW
    //  NCAg̈捶オ_ɂȂ
    OffsetRect(LRect, - FTarget.ClientOrigin.X, - FTarget.ClientOrigin.Y);

    //  {^̕
    LBtnWidth := CaptionHeight();// GetSystemMetrics(SM_CXSIZE);

    //  炵ă`FbN
    for i := 0 to FButtons.Count - 1 do
    begin
        LButton := TCaptionButton(FButtons.Items[i]);
        OffsetRect(LRect, -LBtnWidth, 0);
        if (PtInRect(LRect, APoint) and LButton.Pushed) then
        begin
            LClickIndex := i;
            Result := True;
        end;
        LButton.Pushed := False;
    end;

    //  NbNCxg
    if ((LClickIndex > -1) and Assigned(FOnClick)) then
    begin
        FOnClick(LClickIndex);
    end;
end;

//-----------------------------------------------------------------------------
//  ރEBhEvV[W
procedure TCaptionButtons.WndProc(var Msg: TMessage);
var
    LHandled: Boolean;
    LWMNCLBUTTONDOWN: TWMNCLBUTTONDOWN;
    LWMLBUTTONUP: TWMLBUTTONUP;
begin
    LHandled := False;

    case Msg.Msg of

        WM_CAPTURECHANGED,
        WM_ENTERIDLE,
        WM_NCPAINT,
        WM_SETICON,
        WM_PAINT,
        WM_SYSCOMMAND,
        WM_NCACTIVATE,
        WM_SIZE,
        WM_ACTIVATE,
        WM_SETCURSOR:
        begin
            DrawButtons();
        end;

        WM_NCLBUTTONDOWN:
        begin
            LWMNCLBUTTONDOWN := TWMNCLBUTTONDOWN(Msg);
            LHandled := LeftButtonDown(Point(LWMNCLBUTTONDOWN.XCursor, LWMNCLBUTTONDOWN.YCursor));
            if (LHandled) then SetCapture(FWndHandle);
            DrawButtons();
        end;

        WM_LBUTTONUP:
        begin
            LWMLBUTTONUP := TWMLBUTTONUP(Msg);
            LHandled := LeftButtonUp(Point(LWMLBUTTONUP.XPos, LWMLBUTTONUP.YPos));
            ReleaseCapture();
            DrawButtons();
        end;

//        WM_NCHITTEST    : OnNcPaint(Msg, LHandled);
//        WM_NCLBUTTONDOWN: OnNcLButtonDown(Msg, LHandled);
//        WM_LBUTTONUP    : OnLButtonUp(Msg, LHandled);
//        WM_MOUSEMOVE    : OnMouseMove(Msg, LHandled);
//        WM_ACTIVATE     : OnActivate(Msg, LHandled);
    end;

    // ͂ƃIWis
    if (not LHandled) then
    begin
        Msg.Result := CallWindowProc(FOriginalWndProc, FWndHandle,
                                    Msg.Msg, Msg.wParam, Msg.lParam);
    end;
end;

//------------------------------------------------------------------------------
//  LvV̍
function TCaptionButtons.CaptionHeight(): Integer;
begin
    //  c[o[^
    if (FTarget.BorderStyle in [bsToolWindow, bsSizeToolWin]) then
    begin
        Result := GetSystemMetrics(SM_CYSMCAPTION);
    end
    //  W̃EChE
    else
    begin
        Result := GetSystemMetrics(SM_CYCAPTION);
    end;
end;

//------------------------------------------------------------------------------
//  ^Cgo[̃TCY擾
function TCaptionButtons.CaptionBarRect(): TRect;
var
    LCxSize: Integer;
    LCySize: Integer;
begin
    //  d̃EChE̘g̑
    if (FTarget.BorderStyle in [bsDialog, bsSingle, bsToolWindow]) Then
    begin
        LCxSize := GetSystemMetrics(SM_CXFIXEDFRAME);
        LCySize := GetSystemMetrics(SM_CYFIXEDFRAME);
    end
    else
    //  d̃EChE̘g̑
    begin
        LCxSize := GetSystemMetrics(SM_CXSIZEFRAME);
        LCySize := GetSystemMetrics(SM_CYSIZEFRAME);
    end;

    //  EChETCY擾
    GetWindowRect(FWndHandle, Result);

    //  _Ɉړ
    OffsetRect(Result, - Result.Left, - Result.Top);

    //  g̕
    InflateRect(Result, - LCxSize, - LCySize);

    //  
    Result.Bottom := Result.Top + CaptionHeight() - 1;
end;

//-----------------------------------------------------------------------------
//  ^Cgo[ɂW{^̐𐔂
function TCaptionButtons.DefaultButtonCount(): Integer;
var
    LButtons: TBorderIcons;
begin
    Result := 0;
    LButtons := FTarget.BorderIcons;

    case FTarget.BorderStyle of

    bsDialog:
        begin
            if (biSystemMenu in LButtons) then
            begin
                //  
                Inc(Result);
                //  wv
                if (biHelp in LButtons) then Inc(Result);
            end;
        end;

    bsNone:
        begin
            //  Ȃ
        end;

    bsSingle, bsSizeable:
        begin
            if (biSystemMenu in LButtons) then
            begin
                //  
                Inc(Result);

                //  ȊOɃ{^ЂƂ
                if (LButtons = [biSystemMenu, biMinimize])
                or (LButtons = [biSystemMenu, biMaximize])
                or (LButtons = [biSystemMenu, biHelp]) then
                    Inc(Result, 1)

                //  ȊOɃ{^ӂ
                else
                if (LButtons = [biSystemMenu, biMinimize, biMaximize, biHelp])
                or (LButtons = [biSystemMenu, biMinimize, biMaximize]) then
                    Inc(Result, 2)

                //  ȊOɃ{^݂
                else
                if (LButtons = [biSystemMenu, biMinimize, biHelp])
                or (LButtons = [biSystemMenu, biMaximize, biHelp]) then
                    Inc(Result, 3)
                ;
            end;
        end;

    bsSizeToolWin, bsToolWindow:
        begin
            //  
            if (biSystemMenu in LButtons) then Inc(Result);
        end;
    end;
end;

//------------------------------------------------------------------------------
//  [ɂW{^̗̈擾
function TCaptionButtons.LeftEndDefaultButtonRect(): TRect;
var
    LCxSize: Integer;
    LBtnNum: Integer;
begin
    //  ʏ{^̉擾
    LCxSize := GetSystemMetrics(SM_CXSIZE);

    //  {^̐
    LBtnNum := DefaultButtonCount();

    //  W̃{^̂̈
    Result := CaptionBarRect();
    InflateRect(Result, 0, - 2);    //  l

    Result.Left := Result.Right - LBtnNum * LCxSize;

    //  ԍ[̃{^̗̈
    Result.Right := Result.Left + LCxSize - 2;

    //  c[o[^̃X^C
    if (fTarget.BorderStyle in [bsToolWindow, bsSizeToolWin]) then
    begin
        InflateRect(Result, -3, 0); //  l
        OffsetRect(Result, 6, 0);   //  l
    end;
end;

end.
